<id>
User Templates
</id>

<version>
1.0
</version>

<mod info>
Allow users to customize the forum look to their own preferences by choosing. Includes two sample templates: Default SP1 and Nostalgia Gold Release =D

Instructions:
1) Apply mod file.
2) Upload English.lng, Subs.pl, AdminEdit.pl, Profile.pl and Load.pl to your server.
3) Name your default template "template.html" and upload it to your Templates directory.
4) Upload your other templates to your Templates directory.
5) Visit the Forum Preferences in the admin center and enter your TemplateDir.
6) To edit the templates once they're on the server, go to your "Edit Your Forum Template" screen.
7) Users can select their template in their profile in the "Preferences" section (bottom).



Try clicking on the black coffee part of the coffee cup in the admin center. ;-)
</mod info>

<author>
Michael
</author>

<homepage>
http://www.themikecam.com
</homepage>

<edit file>
English.lng
</edit file>

<search for>
1;
</search for>

<add before>
$templs{'1'} = 'Templates Directory';
$templs{'2'} = 'Forum Template:';
$templs{'3'} = 'Edit a different template:';

</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
</search for>

<replace>
	### User Templates ###
	if(!$tmplfile || !-e("$templatesdir/$tmplfile")) { $tmplfile = "default.html"; }
	if(!-e("$templatesdir/$tmplfile")) { $templatesdir = "$boarddir"; $tmplfile = "template.html"; }

	fopen(TEMPLATE,"$templatesdir/$tmplfile") || die("$txt{'23'}: $tmplfile.html");
#	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
	###/User Templates ###

</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	fopen(FILE, "$boarddir/template.html");
</search for>

<replace>
	### User Templates ###
	if($FORM{'templatefile'}) { $templatefile = $FORM{'templatefile'} }
	else { $templatefile = "default.html"; }
	opendir(TMPLDIR, $templatesdir);
	@templates = readdir(TMPLDIR);
	closedir(TMPLDIR);
	$templs = "";
	foreach $file(sort @templates) {
	    ($name, $ext) = split(/\./, $file);
	    $selected = '';
	    if($ext eq 'html' || $ext eq 'htm') {
		if($file eq $templatefile) { $selected = ' selected'; }
		$templs .= qq~<option value="$file"$selected>$name</option>\n~;
	    }
	}
	fopen(FILE, "$templatesdir/$templatefile");
#	fopen(FILE, "$boarddir/template.html");
	###/User Templates ###
</replace>

<search for>
	fopen(FILE, ">$boarddir/template.html");
</search for>

<replace>

	### User Templates ###
	if($FORM{'templatefile'}) { $templatefile = $FORM{'templatefile'}; }
	else { $templatefile = "default.html"; }
	fopen(FILE, ">$templatesdir/$templatefile");
#	fopen(FILE, ">$boarddir/template.html");
	###/User Templates ###

</replace>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="vardir" size="30" value="$vardir"></td>
</search for>

<add after>
  </tr><tr>
  <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$templs{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="templatesdir" id="templatesdir" size="30" value="$templatesdir"></td>
</add after>

<search for>
	$vardir = $FORM{'vardir'} || "$boarddir/Variables";
</search for>

<add after>
	$templatesdir = $FORM{'templatesdir'} || "$boarddir/Templates";
</add after>

<search for>
\$vardir = "$vardir";         				# Directory with variable files
</search for>

<add after>
\$templatesdir = "$templatesdir";			# Directory with template files.
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	<BR>$txt{'741'}: <i>$proftime</i></font></td>
</search for>

<add after>
	~;

	### User Templates by Michael (mrtorrent@yahoo.com)
	opendir(TMPLDIR, $templatesdir);
	@templates = readdir(TMPLDIR);
	closedir(TMPLDIR);
	$templs = "";
	foreach $file(sort @templates) {
	    ($name, $ext) = split(/\./, $file);
	    $selected = '';
	    if($ext eq 'html' || $ext eq 'htm') {
		if($file eq $tmplfile) { $selected = ' selected'; }
		if((!$tmplfile || !-e("$templatesdir/$tmplfile")) && $name eq 'default') { $selected = ' selected'; }
		$templs .= qq~<option value="$file"$selected>$name</option>\n~;
	    }
	}

$yymain .= qq~
      </tr><tr>
        <td width="320">
	  <font size="2"><b>$templs{'2'}</b></font>
	  <!-- User Templates by Michael(mrtorrent\@yahoo.com) -->
	</td>
	<td width="50">
          <select name="usertemplate" id="usertemplate" size="1">
           $templs</select>
        </td>
</add after>

<search for>
	if($newpassemail) {
</search for>

<add before>
		fopen(TMPL, ">$memberdir/$username.tmpl");
		print TMPL $member{'usertemplate'};
		fclose(TMPL);

</add before>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		}
		else { $username = ''; }
</search for>

<add before>
		       ### User Templates ###
		       fopen(TMPL, "$memberdir/$username.tmpl");
		       @templ = <TMPL>;
		       fclose(TMPL);
		       $tmplfile = @templ[0];
		       if(!-e("$templatesdir/$tmplfile")) { $tmplfile = "default.html"; }
		       ###/User Templates ###
</add before>